%% Lab Demo 4


%% Open function generator and scope

fg = gpib('agilent',7,10);
os = gpib('agilent',7,7);
fopen(fg)
fopen(os)
fprintf(fg,'*IDN?');
idn = fscanf(fg);
fprintf('function generator: %s',idn);
fprintf(os,'*IDN?');
idn = fscanf(os);
fprintf('oscilloscope: %s',idn);
clear idn;

% Set fg output load
fprintf(fg,'Output:Load INF');

%% take data

npts = 20;
freq = logspace(1,3,npts)';
y = zeros(npts,5);
for k=1:npts
    fprintf(fg,'FREQ %g',freq(k));
    y(k,:) = get_data(os);    
end

%% show data

subplot(2,1,1);
yratio = y(:,4);
yphase = y(:,5);
plot(freq,yratio,'ko-','LineWidth',2);
ylabel('voltage ratio');
subplot(2,1,2);
plot(freq,yphase,'ko-','LineWidth',2);
xlabel('frequency (Hz)');
ylabel('phase (degrees)');

%% look for 45-degree phase shift

idx = find(yphase>30 & yphase<60);
fz = interp1(yphase(idx),freq(idx),45);
fprintf(fg,'FREQ %g',fz);
get_data(os);

%% compare time constant to RC

fprintf('time constant %g msec\n',1e3/(2*pi*fz));
R = 1000;
C = 3.55e-6;
tau = R*C;
fprintf('R %g ohms C %g uF tau %g msec.\n',R,C*1e6,tau*1e3);

%% Close all instruments

g = instrfind;
for k=1:length(g)
    fclose(g(k));
    delete(g(k));
end
clear
close all
